## nil

只有 nil 属于该类

## boolean

只有 true 和 false 两个值

Lua会把nil和false当成false，其它的值都为true

## number

双精度浮点数

## string

单引号或双引号表示的是单行字符串

使用`[[....]]`表示多行字符串

```lua
html = [[
<html>
<head></head>
<body>
</body>
</html>
]]
print(html)
```

## function

由C或Lua编写的函数

```lua
-- function_test.lua 脚本文件
function factorial1(n)
    if n == 0 then
        return 1
    else
        return n * factorial1(n - 1)
    end
end
print(factorial1(5))
factorial2 = factorial1
print(factorial2(5))
```

```lua
-- function_test2.lua 脚本文件
function testFun(tab,fun)
        for k ,v in pairs(tab) do
                print(fun(k,v));
        end
end


tab={key1="val1",key2="val2"};
testFun(tab,
function(key,val)--匿名函数
        return key.."="..val;
end
);
```

## userdata

任意存储在变量中的C数据结构

## thread

线程

## table

Lua中的表，类似于字典，key可以是数字、字符串或表

最简单的表是`{}`，表示一个空表

```lua
-- 创建一个空的 table
local tbl1 = {}
 
-- 直接初始表
local tbl2 = {"apple", "pear", "orange", "grape"}
```

```lua
-- table_test.lua 脚本文件
a = {}
a["key"] = "value"
key = 10
a[key] = 22
a[key] = a[key] + 11
for k, v in pairs(a) do
    print(k .. " : " .. v)
end
```

## 获取标志符的类型

使用`type(变量名称)`来判断，返回字符串类型

## 隐式类型转换

在对一个数字字符串上进行算术操作时，Lua 会尝试将这个数字字符串转成一个数字:

```lua
> print("2" + 6)
8.0
> print("2" + "6")
8.0
> print("2 + 6")
2 + 6
> print("-2e2" * "6")
-1200.0
> print("error" + 1)
stdin:1: attempt to perform arithmetic on a string value
stack traceback:
        stdin:1: in main chunk
        [C]: in ?
>
```